package com.sa.ibiz.demo.demo.service.impl;

import java.util.List;
import javax.annotation.Resource;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.mapper.DataEntityMapper;
import com.sa.ibiz.demo.demo.domain.DataEntity;
import com.sa.ibiz.demo.demo.service.DataEntityService;
import com.sa.ibiz.demo.ibizutil.service.ServiceImplBase;
import com.sa.ibiz.demo.demo.service.dto.DataEntitySearchFilter;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import java.util.TreeMap;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import java.lang.reflect.Field;

import com.sa.ibiz.demo.demo.service.DataEntityService;
import com.sa.ibiz.demo.demo.service.QueryModelService;

/**
 * 实体[DataEntity] 服务对象接口实现
 */
@Service
public class DataEntityServiceImpl extends ServiceImplBase<DataEntityMapper, DataEntity> implements DataEntityService{

    @Autowired
    private DataEntityService der11deService;
    @Autowired
    private QueryModelService acquerymodelService;

    @Resource
    private DataEntityMapper dataentityMapper;


    @Override
    public boolean create(DataEntity et) {
        this.beforeCreate(et);
         return super.create(et);
    }
    @Override
    public boolean update(DataEntity et){
        this.beforeUpdate(et);
		this.dataentityMapper.updateOne(et);
		this.get(et);
		return true;
    }

    public Object getEntityKey(DataEntity et){
		return et.getDeid();  
    }

    @Override
    public boolean getDraft(DataEntity et)  {
    if((!StringUtils.isEmpty(et.getDer11deid())) && et.getDer11de() == null){
            try {
                et.setDer11de(der11deService.getById(et.getDer11deid()));
            }catch (Exception ex){}
        }
    if((!StringUtils.isEmpty(et.getAcquerymodelid())) && et.getAcquerymodel() == null){
            try {
                et.setAcquerymodel(acquerymodelService.getById(et.getAcquerymodelid()));
            }catch (Exception ex){}
        }
            return true;
    }
    @Override
    public DataEntity initAll(DataEntity et)  {
		return et;
    }
    @Override
    public DataEntity initUserRoleData(DataEntity et)  {
		return et;
    }

	public List<DataEntity> listDefault(DataEntitySearchFilter filter) {
		return dataentityMapper.searchDefault(filter,filter.getSelectCond());
	}

	public Page<DataEntity> searchDefault(DataEntitySearchFilter filter) {
		return dataentityMapper.searchDefault(filter.getPage(),filter,filter.getSelectCond());
	}

    public  List<Map<String,Object>> selectRow(String sql){
       return dataentityMapper.selectRow(sql);
    }

 }